package dev.thebread

import java.sql.DriverManager
import java.sql.Connection
import java.io.File
import java.sql.PreparedStatement

class KlistApp {

    enum class PreparedStatementCase {
        GET_USERS, GET_LIST_FOR_USER, GET_LISTS, GET_STAGES_FOR_LIST,
        ADD_LIST, ADD_USER, ADD_LIST_FOR_USER, ADD_STAGE_FOR_LIST, ADD_TASK_TO_LIST,
        MOVE_TASK_TO_STAGE,
        REMOVE_TASK, REMOVE_USER, REMOVE_LIST_FOR_USER,
        REG_LOCAL_FOR_USER, REG_DISCORD_FOR_USER, REG_GOOGLE_FOR_USER,
        CLEANUP,
    }

    private var conn: Connection
    private var stmts: Map<PreparedStatementCase, PreparedStatement>

    constructor(path: String?) {
        conn = DriverManager.getConnection(if (!path.isNullOrBlank()) path else "jdbc:sqlite::memory:")
        dbSetup(conn)
        stmts = dbPrepare(conn)
    }

    private fun dbSetup(conn: Connection) {
        val initSql = File("init.sql").readText()
        conn.createStatement().executeUpdate(initSql)
    }

    private fun dbPrepare(conn: Connection): Map<PreparedStatementCase, PreparedStatement> {
        return PreparedStatementCase.entries.associateWith { case ->
            conn.prepareStatement(
                File(
                    "prepare/${
                        case.toString().lowercase()
                    }.sql"
                ).readText()
            )
        }
    }

    private fun assureUser() {}
    private fun assureListForUser() {}
    private fun assureStageForList() {}

    fun createTask() {}
    fun moveTask() {}
    fun deleteTask() {}

    fun createStage() {}
    fun moveStage() {}
    fun deleteStage() {}

    fun deleteUser() {}
}

fun main() {
    val app = KlistApp(null);
    println("Works yay")
}