create table if not exists users (
    id integer primary key,
    name text not null,
    local_id integer,   -- if the thing is running locally
    discord_id integer, -- if logging in via web via discord
    google_id integer -- if logging in via web via google
);

create table if not exists user_lists (
    id integer primary key,
    user_id integer not null,
    list_id integer not null
);

create table if not exists lists (
    id integer primary key,
    name text not null,
    desc text
);

create table if not exists task_stages (
    id integer primary key,
    name text not null,
    desc text,
    list_id integer not null,
    foreign key (list_id) references lists(id)
);

-- this currently enables moving tasks _between lists_ (calculated of course)
create table if not exists tasks (
    id integer primary key,
    name text not null,
    desc text,
    stage integer not null,
    due date,
    due_stage integer, -- more like target stage
    foreign key (stage) references task_stages(id),
    foreign key (due_stage) references task_stages(id)
)